﻿using System.Collections.ObjectModel;
using System.Drawing;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            CreateList();
            Infragistics.Win.AppStyling.StyleManager.Load("styleLib.isl", true);
        }

        private void CreateList()
        {
            Image image = Image.FromFile("users_image.PNG");
            ObservableCollection<ImageGrid> imagesList = new ObservableCollection<ImageGrid>()
            {
                new ImageGrid(image, "image_1"),
                new ImageGrid(image, "image_2"),
                new ImageGrid(image, "image_3")
            };
            this.ultraGrid1.DataSource = imagesList;
        }

        class ImageGrid
        {
            public Image Image { get; set; }
            public string Name { get; set; }

            public ImageGrid(Image image, string name)
            {
                Image = image;
                Name = name;
            }
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            ultraGrid1.DrawFilter = new NoFocusRect();
            ultraGrid1.BeforeSelectChange += ultraGrid1_BeforeSelectChange;
            ultraGrid1.StyleSetName = "ss_ultragrid_comments_no_hottracked";
            e.Layout.Override.CellClickAction = CellClickAction.CellSelect;

            e.Layout.Bands[0].ColHeadersVisible = false;
            e.Layout.Override.CellMultiLine = DefaultableBoolean.True;
            e.Layout.Override.RowSizing = RowSizing.AutoFree;
            e.Layout.Override.SelectTypeCell = e.Layout.Override.SelectTypeRow = SelectType.Single;

            e.Layout.Override.BorderStyleRow = UIElementBorderStyle.None;
            e.Layout.Override.BorderStyleCell = UIElementBorderStyle.Rounded4;

            e.Layout.Bands[0].Columns["Image"].CellAppearance.ImageHAlign = HAlign.Center;
            e.Layout.Bands[0].Columns["Image"].CellAppearance.ImageVAlign = VAlign.Top;


            e.Layout.Override.ActiveAppearancesEnabled = Infragistics.Win.DefaultableBoolean.False;
            // The active cell will still have a grey border around the inside which will look weird when the rest are highlighted, so we also need to do this.
            e.Layout.Override.ActiveCellBorderThickness = 0;
        }
        public class NoFocusRect : IUIElementDrawFilter
        {
            public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
            {
                return true;
            }

            public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
            {
                return DrawPhase.BeforeDrawFocus;
            }
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            e.Row.Appearance.BackColor = Color.White;
            e.Row.Appearance.BorderColor = Color.White;
        }

        private void ultraGrid1_BeforeSelectChange(object sender, BeforeSelectChangeEventArgs e)
        {
            if (e.NewSelections.Cells[0].Column.Key == "Image")
                e.Cancel = true;
        }
    }
}
